<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Decl. Control Flow</TITLE>
<link href="builder_39.html" rel=Next>
<link href="builder_37.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_37.html">previous</A>, <A HREF="builder_39.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC71" HREF="builder_toc.html#TOC71">Structured and Unstructured Control Flow</A></H2>

<P>
The <CODE>FOR</CODE> function will create a structured for loop. By default the
step is set to 1 and the test is set to "&#60;=". These fields can be
specified by using different prototypes of <CODE>FOR</CODE>. The functions
<CODE>IF</CODE>, <CODE>WHILE</CODE>, <CODE>DO</CODE> and <CODE>RETURN</CODE> can be used to
create structured control flow while <CODE>GOTO</CODE> will help generate
unstructured control flow.

</P>
<P>
<A NAME="IDX651"></A>
<A NAME="IDX652"></A>
<A NAME="IDX653"></A>

<PRE>
    block &#38; FOR(block &#38;index, 
                block &#38;lb, 
                block &#38;ub, 
                block &#38;body)
    block &#38; FOR(block &#38;index, 
                block &#38;lb, 
                binary_op test, 
                block &#38;ub, 
                block &#38;body)
    block &#38; FOR(block &#38;index, 
                block &#38;lb, 
                block &#38;ub, 
                block &#38;step, 
                block &#38;body)
    block &#38; FOR(block &#38;index, 
                block &#38;lb, 
                binary_op test, 
                block &#38;ub, 
                block &#38;step, 
                block &#38;body)
<A NAME="IDX654"></A><A NAME="IDX655"></A><A NAME="IDX656"></A>
<A NAME="IDX657"></A><A NAME="IDX658"></A><A NAME="IDX659"></A>    block &#38; IF(block &#38;cond, 
               block &#38;then_part)
    block &#38; IF(block &#38;cond, 
               block &#38;then_part, 
               block &#38;else_part)

    block &#38; WHILE(block &#38;cond, 
                  block &#38;body)
<A NAME="IDX660"></A>    block &#38; DO(block &#38;cond,
               block &#38;body)
<A NAME="IDX661"></A>    block &#38; RETURN();
    block &#38; RETURN(block &#38;val)
<A NAME="IDX662"></A><A NAME="IDX663"></A>    block &#38; GOTO(block &#38;label)
<A NAME="IDX664"></A>    block &#38; procedure(block &#38;, block &#38;, block &#38;)
<A NAME="IDX665"></A></PRE>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_37.html">previous</A>, <A HREF="builder_39.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
